//  PyCOM - Distributed Component Model for Python - C++ Client Library
//  Copyright (c) 2011-2012, Dmitry "Divius" Tantsur
//
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are
//  met:
//
//  * Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
//  * Redistributions in binary form must reproduce the above
//    copyright notice, this list of conditions and the following disclaimer
//    in the documentation and/or other materials provided with the
//    distribution.
//
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
//  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
//  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
//  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
//  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
//  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
//  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
//  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
//  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

#ifndef PYCOM_PRIVATE_H__INCLUDED
#define PYCOM_PRIVATE_H__INCLUDED

#include <string>

#include <zmq.hpp>

#include <pycom-json.h>

namespace pycom {

struct _context_pvt {
    zmq::context_t zcontext;
    std::string ns_address;

    _context_pvt()
        : zcontext(1)
    {}
};

struct _component_pvt {
    _context_pvt *ctx;
    zmq::socket_t zsock;
    std::string iface_name;
    Reader reader;
    FastWriter writer;
    Value session_id;

    _component_pvt(_context_pvt *new_ctx, const std::string &new_iface_name)
        : ctx(new_ctx), zsock(ctx->zcontext, ZMQ_REQ), iface_name(new_iface_name)
    {}
};

} // namespace pycom

#endif // PYCOM_PRIVATE_H__INCLUDED
